## $Id: applicant.py 9071 2012-07-26 16:42:03Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import grok
from zope.interface import implementedBy
from waeup.kofa.applicants.applicant import Applicant, ApplicantFactory
from waeup.kofa.utils.helpers import attrs_to_fields
from kofacustom.nigeria.applicants.interfaces import(
    INigeriaApplicant,
    INigeriaUGApplicantEdit, INigeriaPGApplicantEdit,
    IPUTMEApplicantEdit)

class NigeriaApplicant(Applicant):

    grok.implements(INigeriaApplicant, INigeriaUGApplicantEdit,
        INigeriaPGApplicantEdit, IPUTMEApplicantEdit)
    grok.provides(INigeriaApplicant)

    create_names = Applicant.create_names + [
        'lga', 'nationality', 'perm_address']

# Set all attributes of NigeriaApplicant required in INigeriaApplicant as field
# properties. Doing this, we do not have to set initial attributes
# ourselves and as a bonus we get free validation when an attribute is
# set.
NigeriaApplicant = attrs_to_fields(NigeriaApplicant)

class NigeriaApplicantFactory(ApplicantFactory):
    """A factory for customized applicants.
    """

    def __call__(self, *args, **kw):
        return NigeriaApplicant()

    def getInterfaces(self):
        return implementedBy(NigeriaApplicant)
